# Generated by rust2rpm
%bcond_without check

%global crate skim

Name:           rust-%{crate}
Version:        0.6.6
Release:        1%{?dist}
Summary:        Fuzzy Finder in Rust

License:        MIT
URL:            https://crates.io/crates/skim
Source:         %{crates_source}
# Initial patched metadata
# https://github.com/lotabout/skim/pull/160
# - Bump lazy_static to 1.3.0
# - Bump nix to 0.13.0
# - Bump regex to 1.1.5
Patch0:         skim-fix-metadata.diff
# - Bump log to 0.4.6
Patch1:         skim-0.6.6-bump_log.patch
# - Bump env_logger to 0.6.1
Patch2:         skim-0.6.6-bump_env_logger.patch
ExclusiveArch:  %{rust_arches}

BuildRequires:  rust-packaging
BuildRequires:  (crate(bitflags/default) >= 1.0.4 with crate(bitflags/default) < 2.0.0)
BuildRequires:  (crate(chrono/default) >= 0.4.0 with crate(chrono/default) < 0.5.0)
BuildRequires:  (crate(clap/default) >= 2.26.2 with crate(clap/default) < 3.0.0)
BuildRequires:  (crate(derive_builder/default) >= 0.7.1 with crate(derive_builder/default) < 0.8.0)
BuildRequires:  (crate(env_logger/default) >= 0.6.1 with crate(env_logger/default) < 0.7.0)
BuildRequires:  (crate(fuzzy-matcher/default) >= 0.2.1 with crate(fuzzy-matcher/default) < 0.3.0)
BuildRequires:  (crate(lazy_static/default) >= 1.3.0 with crate(lazy_static/default) < 2.0.0)
BuildRequires:  (crate(log/default) >= 0.4.6 with crate(log/default) < 0.5.0)
BuildRequires:  (crate(nix/default) >= 0.13.0 with crate(nix/default) < 0.14.0)
BuildRequires:  (crate(rayon/default) >= 1.0.3 with crate(rayon/default) < 2.0.0)
BuildRequires:  (crate(regex/default) >= 1.1.5 with crate(regex/default) < 2.0.0)
BuildRequires:  (crate(shlex/default) >= 0.1.1 with crate(shlex/default) < 0.2.0)
BuildRequires:  (crate(time/default) >= 0.1.38 with crate(time/default) < 0.2.0)
BuildRequires:  (crate(timer/default) >= 0.2.0 with crate(timer/default) < 0.3.0)
BuildRequires:  (crate(tuikit/default) >= 0.2.6 with crate(tuikit/default) < 0.3.0)
BuildRequires:  (crate(unicode-width/default) >= 0.1.4 with crate(unicode-width/default) < 0.2.0)
BuildRequires:  (crate(vte/default) >= 0.3.3 with crate(vte/default) < 0.4.0)

%global _description \
Fuzzy Finder in Rust.

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE
%doc CHANGELOG.md README.md
%{_bindir}/sk
%{_bindir}/sk-tmux
%{_mandir}/man1/sk.1.*
%{_mandir}/man1/sk-tmux.1.*
%{_datadir}/skim/
%{_datadir}/vim/vimfiles/plugin/skim.vim
%{_datadir}/nvim/site/plugin/skim.vim
%dir %{_datadir}/bash-completion
%dir %{_datadir}/bash-completion/completions
%{_datadir}/bash-completion/completions/sk
%dir %{_datadir}/zsh
%dir %{_datadir}/zsh/site-functions
%{_datadir}/zsh/site-functions/_sk

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages
which use "%{crate}" crate.

%files          devel
%license LICENSE
%doc CHANGELOG.md README.md
%{cargo_registry}/%{crate}-%{version}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages
which use "default" feature of "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{cargo_registry}/%{crate}-%{version}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
%cargo_prep

# Cleanup interpreters
sed -i -e '/^#!\//, 1d' shell/completion.*
sed -i -e '1d;2i#!/bin/bash' bin/sk-tmux

%build
%cargo_build

%install
%cargo_install
install -Dpm0755 bin/sk-tmux %{buildroot}%{_bindir}/
install -d %{buildroot}%{_mandir}/man1/
install -Dpm0644 man/man1/*.1 %{buildroot}%{_mandir}/man1/

install -d %{buildroot}%{_datadir}/skim

# Install vim plugin
install -d %{buildroot}%{_datadir}/vim/vimfiles/plugin
install -Dpm0644 plugin/skim.vim %{buildroot}%{_datadir}/vim/vimfiles/plugin/
install -d %{buildroot}%{_datadir}/nvim/site/plugin
install -Dpm0644 plugin/skim.vim %{buildroot}%{_datadir}/nvim/site/plugin/

# Install shell completion
install -d %{buildroot}%{_datadir}/bash-completion/completions
install -Dpm0644 shell/completion.bash %{buildroot}%{_datadir}/bash-completion/completions/sk
install -d %{buildroot}%{_datadir}/zsh/site-functions
install -Dpm0644 shell/completion.zsh %{buildroot}%{_datadir}/zsh/site-functions/_sk

# Install shell key bindings (not enabled)
install -d %{buildroot}%{_datadir}/skim/shell
install -Dpm0644 shell/key-bindings.* %{buildroot}%{_datadir}/skim/shell/

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Sun Apr 14 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0.6.6-1
- Initial package
